summaryrefslogtreecommitdiff
path: root/debian/sudo-ldap.postinst
diff options
context:
space:
mode:
authorIgor Pashev <pashev.igor@gmail.com>2017-06-21 14:19:45 +0300
committerIgor Pashev <pashev.igor@gmail.com>2017-06-21 14:19:45 +0300
commit546742e5e8544fb42aa65744d719100b5e32dee4 (patch)
tree2d3ccd186b8ccb02cd134af845cc41aa04e1ff00 /debian/sudo-ldap.postinst
downloadsudo-546742e5e8544fb42aa65744d719100b5e32dee4.tar.gz
Imported sudo 1.8.19p1-2.1debian/1.8.19p1-2.1debian
Diffstat (limited to 'debian/sudo-ldap.postinst')
-rw-r--r--debian/sudo-ldap.postinst79
1 files changed, 79 insertions, 0 deletions
diff --git a/debian/sudo-ldap.postinst b/debian/sudo-ldap.postinst
new file mode 100644
index 0000000..be913a1
--- /dev/null
+++ b/debian/sudo-ldap.postinst
@@ -0,0 +1,79 @@
+#!/bin/sh
+
+set -e
+
+# remove old link
+
+if [ -L /etc/alternatives/sudo ]; then
+ rm /etc/alternatives/sudo
+fi
+
+# complain if no sudoers file is present
+if [ ! -f /etc/sudoers ];then
+ echo "WARNING: /etc/sudoers not present!";
+fi
+
+# modify nsswitch.conf if needed
+if [ -z "`grep \"^sudoers:\" /etc/nsswitch.conf`" ]
+then
+ echo "sudoers: files ldap" >> /etc/nsswitch.conf
+fi
+
+# handle state directory transition from /var/run/sudo to /var/lib/sudo,
+# moving any existing content over to avoid re-lecturing existing users
+if [ -d "/var/run/sudo" ];then
+ mkdir -p /var/lib/sudo
+ (cd /var/run/sudo ; tar cf - .) | (cd /var/lib/sudo ; tar xf -)
+ rm -rf /var/run/sudo
+fi
+
+# make sure sudoers has the correct permissions and owner/group
+if [ -f /etc/sudoers ];then
+ chown root:root /etc/sudoers
+ chmod 440 /etc/sudoers
+fi
+
+# create symlink to ease transition to new path for ldap config
+# if old config file exists and new one doesn't
+if [ -e /etc/ldap/ldap.conf -a ! -e /etc/sudo-ldap.conf ];then
+ ln -s ldap/ldap.conf /etc/sudo-ldap.conf
+fi
+
+# if we've gotten this far .. remove the saved, unchanged old sudoers file
+rm -f /etc/sudoers.pre-conffile
+
+# make sure we have a sudo group
+
+[ -n "`getent group sudo`" ] && exit 0 # we're finished if there is a group sudo:
+
+# start search with gid 27
+gid="27"
+while [ -n "`getent group $gid | cut -d: -f3`" ];do
+ gid=`expr $gid + 1`
+done
+
+
+if [ "$gid" -ne "27" ];then
+ echo "On Debian we normally use gid 27 for 'sudo'."
+ gname="`getent group 27 | cut -d: -f1`"
+ echo "However, on your system gid 27 is group '$gname'."
+ echo ""
+ echo "Would you like me to stop configuring sudo so that you can change this?";
+ while true;do
+ echo -n "(Enter 'yes' to stop, enter to continue): "
+ read ans
+ [ "$ans" = "" ] && break
+ if [ "$ans" = "yes" -o "$ans" = "YES" ];then
+ echo "'dpkg --pending --configure' will restart the configuration."
+ exit 1;
+ fi
+ echo "Please enter exactly 'yes' to stop, or press the enter key to continue without stopping"
+ done
+fi
+
+echo "Creating group 'sudo' with gid = $gid";
+groupadd -g $gid sudo
+
+echo ""
+
+#DEBHELPER#